#include "opencv.bi"

#ifdef __FB_WIN32__
  dim as long videoBackends(...) =>{ CV_CAP_MSMF, CV_CAP_DSHOW, CV_CAP_VFW }
#else
  dim as long videoBackends(...) =>{ CV_CAP_V4L2, CV_CAP_V4L }
#endif  

const size = ubound(videoBackends)+1
dim as IplImage  ptr imageInput,imageOutput

dim as CvCapture ptr capture
' often deviceIndex 0 on PC's are video input of TV or video grabber cards.
' a connected USB camera will have deviceIndex 1 and above
' of course if no PC card are installed the enumeration works also
for deviceIndex as long = 1 to 0 step -1
  for index as integer = 0 to size-1
    capture = cvCreateCameraCapture(videoBackends(index)+deviceIndex)
    if capture = NULL then continue for
    if cvGrabFrame(capture) then exit for,for
    cvReleaseCapture(@capture) : capture = NULL
  next
next  

if capture = NULL then
  print "no active or connected capture device found !"
  beep : sleep : end 1
end if

imageInput = cvRetrieveFrame(capture)
if imageInput<>NULL then imageOutput = cvCloneImage(imageInput)
if imageInput=NULL or imageOutput=NULL then
  cvReleaseCapture(@capture)
  print "Oh no something goes wrong images = NULL !"
  beep : sleep : beep:end 1
end if

var videoWidth   = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH)
var videoHeight  = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT)

' create 2 windows
cvNamedWindow ("winInput")  
cvMoveWindow  ("winInput",0,0)

cvNamedWindow ("winOutput")
cvMoveWindow  ("winOutput",videoWidth,0)


' loop while [ESC] not pressed
while cvWaitKey(10)<>27
  ' grab and retrieve in one go
  imageInput = cvQueryFrame(capture)
  if imageInput <> NULL then 
    ' use any filter/effect
    cvSmooth( imageInput, imageOutput, CV_GAUSSIAN,9,9)    
    cvShowImage("winInput",imageInput) 
    cvShowImage("winOutput",imageOutput) 
  end if  
wend
if imageOutput<>NULL then cvReleaseImage(@imageOutput)
if capture<>NULL then cvReleaseCapture(@capture)
cvDestroyAllWindows()
