#include "opencv.bi"

#ifdef __FB_WIN32__
  dim as long videoBackends(...) =>{ CV_CAP_MSMF, CV_CAP_DSHOW, CV_CAP_VFW }
#else
  dim as long videoBackends(...) =>{ CV_CAP_V4L2, CV_CAP_V4L }
#endif  

const size = ubound(videoBackends)+1

dim as CvCapture ptr capture
for deviceIndex as long = 1 to 0 step -1
  for index as integer = 0 to size-1
    capture = cvCreateCameraCapture(videoBackends(index)+deviceIndex)
    if capture = NULL then continue for
    if cvGrabFrame(capture) then exit for,for
    cvReleaseCapture(@capture) : capture = NULL
  next
next  

if capture = NULL then
  print "no active or connected capture device found !"
  beep : sleep :end 1
end if

dim as IplImage ptr videoImage
var videoCounter = 0

'cvSetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH ,320)
'cvSetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT,240)

var videoWidth   = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH)
var videoHeight  = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT)
var videoFPS     = cvGetCaptureProperty(capture,CV_CAP_PROP_FPS)
dim as long viodeoFOURCC = cvGetCaptureProperty(capture,CV_CAP_PROP_FOURCC)
dim as zstring ptr stringFOURCC = callocate(5)
*cptr(ulong ptr,stringFOURCC)=viodeoFOURCC

if videoFPS<=0 then videoFPS = 24
locate 1,1 : print videoWidth,videoHeight,hex(viodeoFOURCC,8),*stringFOURCC,videoFPS

' create 'named' window
cvNamedWindow("winMain")
cvResizeWindow("winMain",videoWidth,videoHeight)

' loop while [ESC] not pressed
while cvWaitKey(10)<>27
#if 0  
  ' grab and retrieve in one go
  videoImage = cvQueryFrame(capture)
#else
  if cvGrabFrame(capture) then
    videoImage = cvRetrieveFrame(capture)
  end if
#endif  
  if videoImage <> 0 then 
    cvShowImage("winMain",videoImage) 
    videoCounter+=1
    locate 2,1 : print videoCounter
    videoImage = NULL
  end if  
wend

cvReleaseCapture(@capture)
cvDestroyAllWindows()
