#include "opencv.bi"

function cvImageToFBImage( cvImage as IplImage ptr) as any ptr
  dim as integer srcWidth,srcHeight,srcBytes,srcPitch,srcBits
  dim as integer dstWidth,dstHeight,dstBytes,dstPitch,dstBits
  dim as ubyte ptr dstPixels,srcPixels
  dim as any ptr fbImage
  if cvImage=NULL then return NULL
  if screenptr()=NULL then return NULL
  ' destination
  screeninfo dstWidth,dstHeight,dstBits,dstBytes
  fbImage   = ImageCreate(dstWidth,dstHeight,&HFFFFFF)
  ImageInfo fbImage,,,,dstPitch,dstPixels
  
  ' source
  srcWidth  = cvImage->width
  srcHeight = cvImage->height
  srcBytes  = cvImage->nChannels
  srcBits   = srcBytes shl 3
  srcPitch  = cvImage->widthStep
  srcPixels = cvImage->imageData
  ' get shortes dimension (in case cvImage or fbImage are smaller)
  srcWidth  = iif(srcWidth <dstWidth ,srcWidth ,dstWidth )
  srcHeight = iif(srcHeight<dstHeight,srcHeight,dstHeight)
  
  while srcHeight     ' false = don't swap red and blue
    ImageConvertRow ( srcPixels, srcBits, dstPixels, dstBits, srcWidth, false )
    srcPixels+=srcPitch
    dstPixels+=dstPitch
    srcHeight-=1
  wend
  return fbImage
end function



#ifdef __FB_WIN32__
  dim as long videoBackends(...) =>{ CV_CAP_DSHOW, CV_CAP_VFW }
#else
  dim as long videoBackends(...) =>{ CV_CAP_V4L2, CV_CAP_V4L }
#endif  

const size = ubound(videoBackends)+1

dim as CvCapture ptr capture
for deviceIndex as long = 1 to 0 step -1
  for index as integer = 0 to size-1
    capture = cvCreateCameraCapture(videoBackends(index)+deviceIndex)
    if capture = NULL then continue for
    if cvGrabFrame(capture) then exit for,for
    cvReleaseCapture(@capture) : capture = NULL
  next
next  

if capture = NULL then
  print "no active or connected capture device found !"
  beep : sleep :end 1
end if

dim as IplImage ptr cvImage
var videoWidth  = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH)
var videoHeight = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT)
var videoFPS    = cvGetCaptureProperty(capture,CV_CAP_PROP_FPS)

'screenres videoWidth*1.5,videoHeight*1.5,32
screenres videoWidth ,videoHeight,32


' loop while [ESC] not pressed
while asc(inkey())<>27

  ' grab next videoframe and retrieve it in one go !
  cvImage = cvQueryFrame(capture)
  if cvImage <> NULL then
    var fbImage = cvImageToFBImage(cvImage)
    if fbImage then
      put (0,0),fbImage,PSET
      ImageDestroy(fbImage)
    end if  
    cvImage = NULL
  end if  
  sleep 10 '1000/videoFPS
wend

cvReleaseCapture(@capture)
