#include "opencv.bi"

' mouse callback
sub cbMouse CV_CDECL ( event as long, x as long, y as long, flags as long, userdata as any ptr )
  static as long ox=-1,oy=-1,of=-1
  ' print event,x,y,flags
  select case as const event
  case CV_EVENT_MOUSEMOVE     
    if ox<>x orelse oy<>y orelse of<>flags then 
      print "MOUSEMOVE",x,y 
      ox=x : oy=y : of=flags
    end if  
  case CV_EVENT_LBUTTONDOWN   : print "Left Button Down"
  case CV_EVENT_RBUTTONDOWN   : print "Right Button Down"
  case CV_EVENT_MBUTTONDOWN   : print "Middle Button Down"
  case CV_EVENT_LBUTTONUP     : print "Left Button Up"
  case CV_EVENT_RBUTTONUP     : print "Right Button Up"
  case CV_EVENT_MBUTTONUP     : print "Middle Button Up"
  case CV_EVENT_LBUTTONDBLCLK : print "Left Button Doubleclick"
  case CV_EVENT_RBUTTONDBLCLK : print "Right Button Doubleclick"
  case CV_EVENT_MBUTTONDBLCLK : print "Middle Button Doubleclick"
  case else : print "event: " & event
  end select  
  
  if flags=0 then exit sub
  dim as string sFlags 
  if (flags and CV_EVENT_FLAG_LBUTTON)  then sFlags &= "Left Button "
  if (flags and CV_EVENT_FLAG_RBUTTON)  then sFlags &= "Right Button "
  if (flags and CV_EVENT_FLAG_MBUTTON)  then sFlags &= "Middle Button "
  if (flags and CV_EVENT_FLAG_CTRLKEY)  then sFlags &= "[CTRL] Key "
  if (flags and CV_EVENT_FLAG_SHIFTKEY) then sFlags &= "[SHIFT] Key "
  if (flags and CV_EVENT_FLAG_ALTKEY)   then sFlags &= "[ALT] Key"
  print sFlags
  of=flags
end sub

cvNamedWindow("win") : cvResizeWindow("win",640,480)
cvSetMouseCallback("win",@cbMouse,NULL)

' loop with 10Hz while [ESC] not pressed
while cvWaitKey(1000/10)<>27
  ' ...
wend

cvDestroyWindow("win")
