#pragma once

#define __OPENCV__

#include once "crt.bi"

#ifndef DBL_EPSILON
 #define DBL_EPSILON  2.2204460492503131e-016
#endif

#ifndef NULL 
 #define NULL cptr(any ptr,0) 
#endif

#ifdef __FB_WIN32__
 
 #ifndef __FB_64BIT__
  #libpath "lib/win32"
 #else
  #libpath "lib/win64"
 #endif
 
 #include "winconfig.bi"
 #include "winmodules.bi"

 #ifdef HAVE_OPENCV_CORE 
  #inclib "opencv_core2413"
 #endif
 #ifdef HAVE_OPENCV_IMGPROC
  #inclib "opencv_imgproc2413"
 #endif
 #ifdef HAVE_OPENCV_HIGHGUI
  #inclib "opencv_highgui2413"
 #endif
 #ifdef HAVE_OPENCV_LEGACY
  #inclib "opencv_legacy2413"
 #endif 
 #ifdef HAVE_OPENCV_CALIB3D
  #inclib "opencv_calib3d2413"
 #endif
 #ifdef HAVE_OPENCV_VIDEO
  #inclib "opencv_video2413"
 #endif 
 #ifdef HAVE_OPENCV_VIDEOSTAB
  #inclib "opencv_videostab2413"
 #endif
 #ifdef HAVE_OPENCV_CALIB3D
  #inclib "opencv_objdetect2413"
 #endif
 #ifdef HAVE_OPENCV_PHOTO
  #inclib "opencv_photo2413"
 #endif
 #ifdef HAVE_OPENCV_STITCHING
  #inclib "opencv_stitching2413"
 #endif
 #ifdef HAVE_OPENCV_SUPERRES
  #inclib "opencv_superres2413"
 #endif 

#else ' linux

 #include "linconfig.bi"
 #include "linmodules.bi"
 
 #ifdef HAVE_OPENCV_CORE 
  #inclib "opencv_core"
 #endif
 #ifdef HAVE_OPENCV_IMGPROC
  #inclib "opencv_imgproc"
 #endif
 #ifdef HAVE_OPENCV_HIGHGUI
  #inclib "opencv_highgui"
 #endif
 #ifdef HAVE_OPENCV_LEGACY
  #inclib "opencv_legacy"
 #endif 
 #ifdef HAVE_OPENCV_CALIB3D
  #inclib "opencv_calib3d"
 #endif
 #ifdef HAVE_OPENCV_VIDEO
  #inclib "opencv_video"
 #endif 
 #ifdef HAVE_OPENCV_VIDEOSTAB
  #inclib "opencv_videostab"
 #endif
 #ifdef HAVE_OPENCV_CALIB3D
  #inclib "opencv_objdetect"
 #endif
 #ifdef HAVE_OPENCV_PHOTO
  #inclib "opencv_photo"
 #endif
 #ifdef HAVE_OPENCV_STITCHING
  #inclib "opencv_stitching"
 #endif
 #ifdef HAVE_OPENCV_SUPERRES
  #inclib "opencv_superres"
 #endif 

#endif 

#include "opencv_core_types.bi"
#include "opencv_core.bi"
#include "opencv_imgproc_types.bi"
#include "opencv_imgproc.bi"
#include "opencv_highgui.bi"
#include "opencv_compat.bi"
#include "opencv_legacy.bi"
#include "opencv_calib3d.bi"
#include "opencv_video.bi"
#include "opencv_objdetect.bi"
#include "opencv_photo.bi"
