#pragma once

#ifndef __OPENCV__
  #error 666: do not include this file manually include only 'opencv.bi' !
#endif

' A few macros and definitions for backward compatibility
' with the previous versions of OpenCV. 
' They are obsolete and are likely to be removed in future. 
' To check whether your code uses any of these, 
' define CV_NO_BACKWARD_COMPATIBILITY before including cv.h.

'#include "opencv_core.bi"
'#include "opencv_imgproc_types.bi"

extern "C"

'typedef int CvMatType;
'typedef int CvDisMaskType;
'typedef CvMat CvMatArray;

'typedef int CvThreshType;
'typedef int CvAdaptiveThreshMethod;
'typedef int CvCompareMethod;
'typedef int CvFontFace;
'typedef int CvPolyApproxMethod;
'typedef int CvContoursMatchMethod;
'typedef int CvContourTreesMatchMethod;
'typedef int CvCoeffType;
'typedef int CvRodriguesType;
'typedef int CvElementShape;
'typedef int CvMorphOp;
'typedef int CvTemplMatchMethod;

'typedef CvPoint2D64f CvPoint2D64d;
'typedef CvPoint3D64f CvPoint3D64d;

enum
  CV_MAT32F      = CV_32FC1,
  CV_MAT3x1_32F  = CV_32FC1,
  CV_MAT4x1_32F  = CV_32FC1,
  CV_MAT3x3_32F  = CV_32FC1,
  CV_MAT4x4_32F  = CV_32FC1,

  CV_MAT64D      = CV_64FC1,
  CV_MAT3x1_64D  = CV_64FC1,
  CV_MAT4x1_64D  = CV_64FC1,
  CV_MAT3x3_64D  = CV_64FC1,
  CV_MAT4x4_64D  = CV_64FC1
end enum

enum
  IPL_GAUSSIAN_5x5 = 7
end enum

'type CvBox2D32f as CvBox2D

' allocation/deallocation macros
#define cvCreateImageData   cvCreateData
#define cvReleaseImageData  cvReleaseData
#define cvSetImageData      cvSetData
#define cvGetImageRawData   cvGetRawData

#define cvmAlloc            cvCreateData
#define cvmFree             cvReleaseData
#define cvmAllocArray       cvCreateData
#define cvmFreeArray        cvReleaseData

#define cvIntegralImage     cvIntegral
#define cvMatchContours     cvMatchShapes

declare function cvMatArray( rows as long, cols as long, type_  as long, _
                             count as long, data as any ptr CV_DEFAULT(NULL) ) as CvMat

#define cvUpdateMHIByTime  cvUpdateMotionHistory

#define cvAccMask cvAcc
#define cvSquareAccMask cvSquareAcc
#define cvMultiplyAccMask cvMultiplyAcc
#define cvRunningAvgMask(imgY, imgU, mask, alpha) cvRunningAvg(imgY, imgU, alpha, mask)

#define cvSetHistThresh  cvSetHistBinRanges
#define cvCalcHistMask(img, mask, hist, doNotClear) cvCalcHist(img, hist, doNotClear, mask)

declare function cvMean( image as const CvArr ptr, mask as const CvArr ptr CV_DEFAULT(NULL) ) as double
declare function cvSumPixels( image as const CvArr ptr ) as double
declare sub      cvMean_StdDev( image as const CvArr ptr, mean as double ptr, sdv as double ptr, _
                                mask as const CvArr ptr CV_DEFAULT(NULL) )

declare sub      cvmPerspectiveProject( mat as const CvMat ptr, src as const CvArr ptr, dst as CvArr ptr )
declare sub      cvFillImage( mat as CvArr ptr, colour as double )

#define cvCvtPixToPlane cvSplit
#define cvCvtPlaneToPix cvMerge

type CvRandState
  as CvRNG    state    ' RNG state (the current seed and carry)
  as long     disttype ' distribution type
  as CvScalar param(1) ' parameters of RNG
end type

' Changes RNG range while preserving RNG state
declare sub      cvRandSetRange( state as CvRandState ptr, param1 as double, _
                                 param2 as double, index as long CV_DEFAULT(-1) )

declare sub      cvRandInit( state as CvRandState ptr, param1 as double, _
                             param2 as double, seed as long, _
                             disttype as long CV_DEFAULT(CV_RAND_UNI) )

' Fills array with random numbers
declare sub      cvRand( state as CvRandState ptr, arr as CvArr ptr )

#define cvRandNext( _state ) cvRandInt( @(_state)->state )

declare sub      cvbRand( state as CvRandState ptr, dst as single ptr, len_ as long )

declare sub      cvbCartToPolar( y as const single ptr, x as const single ptr, _
                                 magnitude as single ptr, angle as single ptr, len_ as long )
declare sub      cvbFastArctan( y as const single ptr, x as const single ptr, angle as single ptr, len_ as long)
declare sub      cvbSqrt( x as const single ptr, y as single ptr, len_ as long )
declare sub      cvbInvSqrt( x as const single ptr, y as single ptr, len_ as long )
declare sub      cvbReciprocal( x as const single ptr, y as single ptr, len_ as long )
declare sub      cvbFastExp( x as const single ptr, y as double ptr, len_ as long )
declare sub      cvbFastLog( x as const double ptr, y as single ptr, len_ as long )

declare function cvContourBoundingRect( point_set as any ptr, update as long CV_DEFAULT(0)) as CvRect

declare function cvPseudoInverse( src as const CvArr ptr, dst as CvArr ptr ) as double
#define cvPseudoInv cvPseudoInverse

#define cvContourMoments( contour, moments ) cvMoments( contour, moments, 0 )

#define cvGetPtrAt              cvPtr2D
#define cvGetAt                 cvGet2D
#define cvSetAt(arr,val,y,x)    cvSet2D((arr),(y),(x),(val))

#define cvMeanMask  cvMean
#define cvMean_StdDevMask(img,mask,mean,sdv) cvMean_StdDev(img,mean,sdv,mask)

#define cvNormMask(imgA,imgB,mask,normType) cvNorm(imgA,imgB,normType,mask)

#define cvMinMaxLocMask(img, mask, min_val, max_val, min_loc, max_loc) _
        cvMinMaxLoc(img, min_val, max_val, min_loc, max_loc, mask)

#define cvRemoveMemoryManager  cvSetMemoryManager

#define cvmSetZero( mat )               cvSetZero( mat )
#define cvmSetIdentity( mat )           cvSetIdentity( mat )
#define cvmAdd( src1, src2, dst )       cvAdd( src1, src2, dst, 0 )
#define cvmSub( src1, src2, dst )       cvSub( src1, src2, dst, 0 )
#define cvmCopy( src, dst )             cvCopy( src, dst, 0 )
#define cvmMul( src1, src2, dst )       cvMatMulAdd( src1, src2, 0, dst )
#define cvmTranspose( src, dst )        cvT( src, dst )
#define cvmInvert( src, dst )           cvInv( src, dst )
#define cvmMahalanobis(vec1, vec2, mat) cvMahalanobis( vec1, vec2, mat )
#define cvmDotProduct( vec1, vec2 )     cvDotProduct( vec1, vec2 )
#define cvmCrossProduct(vec1, vec2,dst) cvCrossProduct( vec1, vec2, dst )
#define cvmTrace( mat )                 (cvTrace( mat )).val[0]
#define cvmMulTransposed( src, dst, order ) cvMulTransposed( src, dst, order )
#define cvmEigenVV( mat, evec, eval, eps) cvEigenVV( mat, evec, eval, eps )
#define cvmDet( mat )                   cvDet( mat )
#define cvmScale( src, dst, scale )     cvScale( src, dst, scale )

#define cvCopyImage( src, dst )         cvCopy( src, dst, 0 )
#define cvReleaseMatHeader              cvReleaseMat

' Calculates exact convex hull of 2d point set
declare sub      cvConvexHull( points as CvPoint ptr, num_points as long, _
                               bound_rect as CvRect ptr, orientation as long, _
                               hull as long ptr,  hullsize as long ptr )


declare sub      cvMinAreaRect( points as CvPoint ptr, n as long, _
                                left_ as long, bottom as long, _
                                right_  as long, top as long, _
                                anchor as CvPoint2D32f ptr, _
                                vect1 as CvPoint2D32f ptr, _
                                vect2 as CvPoint2D32f ptr )

type CvDisType as long
type CvChainApproxMethod as long
type CvContourRetrievalMode as long

declare sub      cvFitLine3D( points as CvPoint3D32f ptr, count as long, dist as long, _
                              param as any ptr, reps as single, aeps as single, line_ as single ptr )

' Fits a line into set of 2d points in a robust way (M-estimator technique)
declare sub      cvFitLine2D( points as CvPoint2D32f ptr, count as long, dist as long, _
                              param as any ptr, reps as single, aeps as single, line_ as single ptr)

declare sub      cvFitEllipse( points as const CvPoint2D32f ptr, count as long, box as CvBox2D ptr )

' Projects 2d points to one of standard coordinate planes (i.e. removes one of coordinates)
declare sub      cvProject3D( points3D as CvPoint3D32f ptr, count as long, _
                              points2D as CvPoint2D32f ptr, _
                              xIndx as long CV_DEFAULT(0), _
                              yIndx as long CV_DEFAULT(1) )

' Retrieves value of the particular bin of x-dimensional (x=1,2,3,...) histogram
#define cvQueryHistValue_1D( hist, idx0 ) _
    csng(cvGetReal1D( (hist)->bins, (idx0)))
#define cvQueryHistValue_2D( hist, idx0, idx1 ) _
    csng(cvGetReal2D( (hist)->bins, (idx0), (idx1)))
#define cvQueryHistValue_3D( hist, idx0, idx1, idx2 ) _
    csng(cvGetReal3D( (hist)->bins, (idx0), (idx1), (idx2)))
#define cvQueryHistValue_nD( hist, idx ) _
    csng(cvGetRealND( (hist)->bins, (idx)))

' Returns pointer to the particular bin of x-dimesional histogram.
' For sparse histogram the bin is created if it didn't exist before
#define cvGetHistValue_1D( hist, idx0 ) _
    cptr(single ptr,cvPtr1D( (hist)->bins, (idx0), 0))
#define cvGetHistValue_2D( hist, idx0, idx1 ) _
    cptr(single ptr,cvPtr2D( (hist)->bins, (idx0), (idx1), 0))
#define cvGetHistValue_3D( hist, idx0, idx1, idx2 ) _
    cptr(single ptr,cvPtr3D( (hist)->bins, (idx0), (idx1), (idx2), 0))
#define cvGetHistValue_nD( hist, idx ) _
    cptr(single ptr,cvPtrND( (hist)->bins, (idx), 0))

#define CV_IS_SET_ELEM_EXISTS CV_IS_SET_ELEM


declare function cvHoughLines( image       as CvArr ptr, _
                               rho         as double, _
                               theta       as double, _
                               threshold   as long, _
                               lines       as single ptr, _
                               linesNumber as long ) as long

declare function cvHoughLinesP( image       as CvArr ptr, _
                                rho         as double, _
                                theta       as double, _
                                threshold   as long, _
                                lineLength  as long, _
                                lineGap     as long, _
                                lines       as long ptr, _
                                linesNumber as long ) as long


declare function cvHoughLinesSDiv( image as CvArr ptr, _
                                   rho   as double, _
                                   srn   as long, _
                                   theta as double, _
                                   stn   as long, _
                                   threshold   as long, _
                                   lines       as single ptr, _
                                   linesNumber as long ) as long

declare function cvCalcEMD( signature1  as const single ptr, _
                            size1       as long, _
                            signature2  as const single ptr, _
                            size2       as long, _
                            dims        as long, _
                            dist_type   as long CV_DEFAULT(CV_DIST_L2), _
                            dist_func   as CvDistanceFunction CV_DEFAULT(NULL), _
                            lower_bound as single ptr CV_DEFAULT(NULL), _
                            user_param  as any ptr CV_DEFAULT(NULL) ) as single

declare sub      cvKMeans( num_clusters as long, _
                           samples      as single ptr ptr, _
                           num_samples  as long, _
                           vec_size     as long, _
                           termcrit     as CvTermCriteria, _
                           cluster_idx  as long ptr )

declare sub      cvStartScanGraph( graph   as CvGraph ptr, _
                                   scanner as CvGraphScanner ptr, _
                                   vtx     as CvGraphVtx ptr CV_DEFAULT(NULL), _
                                   mask    as long CV_DEFAULT(CV_GRAPH_ALL_ITEMS) )

declare sub      cvEndScanGraph( scanner as CvGraphScanner ptr )


' old drawing functions
declare sub      cvLineAA( img    as CvArr ptr, _
                           pt1    as CvPoint, _
                           pt2    as CvPoint, _
                           colour as double, _
                           scale  as long CV_DEFAULT(0) )

declare sub      cvCircleAA( img    as CvArr ptr, _
                             center as CvPoint, _
                             radius as long, _
                             colour as double, _
                             scale  as long CV_DEFAULT(0) )

declare sub      cvEllipseAA( img         as CvArr ptr, _
                              center      as CvPoint, _
                              axes        as CvSize, _
                              angle       as double, _
                              start_angle as double, _
                              end_angle   as double, _
                              colour      as double, _
                              scale       as long CV_DEFAULT(0) )

declare sub      cvPolyLineAA( img       as CvArr ptr, _
                               pts       as CvPoint ptr ptr, _
                               npts      as long ptr, _
                               contours  as long, _
                               is_closed as long, _
                               colour    as double, _
                               scale     as long CV_DEFAULT(0) )

#if 0
' #######################
' # Pixel Access Macros #
' #######################
/* Initialize one of the CvPixelPosition structures.   */
/*  pos    - initialized structure                     */
/*  origin - pointer to the left-top corner of the ROI */
/*  step   - width of the whole image in bytes         */
/*  roi    - width & height of the ROI                 */
/*  x, y   - initial position                          */
#define CV_INIT_PIXEL_POS(pos, origin, _step, roi, _x, _y, orientation)    \
    (                                                                        \
    (pos).step = (_step)/sizeof((pos).currline[0]) * (orientation ? -1 : 1), \
    (pos).width = (roi).width,                                               \
    (pos).height = (roi).height,                                             \
    (pos).bottomline = (origin) + (pos).step*(pos).height,                   \
    (pos).topline = (origin) - (pos).step,                                   \
    (pos).step_arr[0] = 0,                                                   \
    (pos).step_arr[1] = -(pos).step,                                         \
    (pos).step_arr[2] = (pos).step,                                          \
    (pos).x = (_x),                                                          \
    (pos).currline = (origin) + (pos).step*(_y) )


/* Move to specified point ( absolute shift ) */
/*  pos    - position structure               */
/*  x, y   - coordinates of the new position  */
/*  cs     - number of the image channels     */
#define CV_MOVE_TO( pos, _x, _y, cs )                                                   \
((pos).currline = (_y) >= 0 && (_y) < (pos).height ? (pos).topline + ((_y)+1)*(pos).step : 0, \
 (pos).x = (_x) >= 0 && (_x) < (pos).width ? (_x) : 0, (pos).currline + (_x) * (cs) )

/* Get current coordinates                    */
/*  pos    - position structure               */
/*  x, y   - coordinates of the new position  */
/*  cs     - number of the image channels     */
#define CV_GET_CURRENT( pos, cs )  ((pos).currline + (pos).x * (cs))

/* Move by one pixel relatively to current position */
/*  pos    - position structure                     */
/*  cs     - number of the image channels           */

/* left */
#define CV_MOVE_LEFT( pos, cs ) \
 ( --(pos).x >= 0 ? (pos).currline + (pos).x*(cs) : 0 )

/* right */
#define CV_MOVE_RIGHT( pos, cs ) \
 ( ++(pos).x < (pos).width ? (pos).currline + (pos).x*(cs) : 0 )

/* up */
#define CV_MOVE_UP( pos, cs ) \
 (((pos).currline -= (pos).step) != (pos).topline ? (pos).currline + (pos).x*(cs) : 0 )

/* down */
#define CV_MOVE_DOWN( pos, cs ) \
 (((pos).currline += (pos).step) != (pos).bottomline ? (pos).currline + (pos).x*(cs) : 0 )

/* left up */
#define CV_MOVE_LU( pos, cs ) ( CV_MOVE_LEFT(pos, cs), CV_MOVE_UP(pos, cs))

/* right up */
#define CV_MOVE_RU( pos, cs ) ( CV_MOVE_RIGHT(pos, cs), CV_MOVE_UP(pos, cs))

/* left down */
#define CV_MOVE_LD( pos, cs ) ( CV_MOVE_LEFT(pos, cs), CV_MOVE_DOWN(pos, cs))

/* right down */
#define CV_MOVE_RD( pos, cs ) ( CV_MOVE_RIGHT(pos, cs), CV_MOVE_DOWN(pos, cs))



/* Move by one pixel relatively to current position with wrapping when the position     */
/* achieves image boundary                                                              */
/*  pos    - position structure                                                         */
/*  cs     - number of the image channels                                               */

/* left */
#define CV_MOVE_LEFT_WRAP( pos, cs ) \
 ((pos).currline + ( --(pos).x >= 0 ? (pos).x : ((pos).x = (pos).width-1))*(cs))

/* right */
#define CV_MOVE_RIGHT_WRAP( pos, cs ) \
 ((pos).currline + ( ++(pos).x < (pos).width ? (pos).x : ((pos).x = 0))*(cs) )

/* up */
#define CV_MOVE_UP_WRAP( pos, cs ) \
    ((((pos).currline -= (pos).step) != (pos).topline ? \
    (pos).currline : ((pos).currline = (pos).bottomline - (pos).step)) + (pos).x*(cs) )

/* down */
#define CV_MOVE_DOWN_WRAP( pos, cs ) \
    ((((pos).currline += (pos).step) != (pos).bottomline ? \
    (pos).currline : ((pos).currline = (pos).topline + (pos).step)) + (pos).x*(cs) )

/* left up */
#define CV_MOVE_LU_WRAP( pos, cs ) ( CV_MOVE_LEFT_WRAP(pos, cs), CV_MOVE_UP_WRAP(pos, cs))
/* right up */
#define CV_MOVE_RU_WRAP( pos, cs ) ( CV_MOVE_RIGHT_WRAP(pos, cs), CV_MOVE_UP_WRAP(pos, cs))
/* left down */
#define CV_MOVE_LD_WRAP( pos, cs ) ( CV_MOVE_LEFT_WRAP(pos, cs), CV_MOVE_DOWN_WRAP(pos, cs))
/* right down */
#define CV_MOVE_RD_WRAP( pos, cs ) ( CV_MOVE_RIGHT_WRAP(pos, cs), CV_MOVE_DOWN_WRAP(pos, cs))

#endif

' Numeric constants which used for moving in arbitrary direction
enum
  CV_SHIFT_NONE = 2,
  CV_SHIFT_LEFT = 1,
  CV_SHIFT_RIGHT = 3,
  CV_SHIFT_UP = 6,
  CV_SHIFT_DOWN = 10,
  CV_SHIFT_LU = 5,
  CV_SHIFT_RU = 7,
  CV_SHIFT_LD = 9,
  CV_SHIFT_RD = 11
end enum

#if 0
/* Move by one pixel in specified direction                                     */
/*  pos    - position structure                                                 */
/*  shift  - direction ( it's value must be one of the CV_SHIFT_ constants ) */
/*  cs     - number of the image channels                                       */
#define CV_MOVE_PARAM( pos, shift, cs )                                             \
    ( (pos).currline += (pos).step_arr[(shift)>>2], (pos).x += ((shift)&3)-2,       \
    ((pos).currline != (pos).topline && (pos).currline != (pos).bottomline &&       \
    (pos).x >= 0 && (pos).x < (pos).width) ? (pos).currline + (pos).x*(cs) : 0 )

/* Move by one pixel in specified direction with wrapping when the               */
/* position achieves image boundary                                              */
/*  pos    - position structure                                                  */
/*  shift  - direction ( it's value must be one of the CV_SHIFT_ constants )  */
/*  cs     - number of the image channels                                        */
#define CV_MOVE_PARAM_WRAP( pos, shift, cs )                                        \
    ( (pos).currline += (pos).step_arr[(shift)>>2],                                 \
    (pos).currline = ((pos).currline == (pos).topline ?                             \
    (pos).bottomline - (pos).step :                                                 \
    (pos).currline == (pos).bottomline ?                                            \
    (pos).topline + (pos).step : (pos).currline),                                   \
                                                                                    \
    (pos).x += ((shift)&3)-2,                                                       \
    (pos).x = ((pos).x < 0 ? (pos).width-1 : (pos).x >= (pos).width ? 0 : (pos).x), \
                                                                                    \
    (pos).currline + (pos).x*(cs) )

typedef float*   CvVect32f;
typedef float*   CvMatr32f;
typedef double*  CvVect64d;
typedef double*  CvMatr64d;

#endif

declare sub      cvUnDistortOnce( src               as const CvArr ptr, _
                                  dst               as CvArr ptr, _
                                  intrinsic_matrix  as const single ptr, _
                                  distortion_coeffs as const single ptr, _
                                  interpolate       as long )

' the two functions below have quite hackerish implementations, use with care
' (or, which is better, switch to cvUndistortInitMap and cvRemap instead 
declare sub      cvUnDistortInit( src              as const CvArr ptr, _
                                  undistortion_map as CvArr ptr, _
                                  A                as const single ptr, _
                                  k                as const single ptr, _
                                  interpolate      as long )

declare sub      cvUnDistort( src              as const CvArr ptr, _
                              dst              as CvArr ptr, _
                              undistortion_map as const CvArr ptr, _
                              interpolate      as long )

' Find fundamental matrix
declare sub      cvFindFundamentalMatrix( points1   as long ptr, _
                                          points2   as long ptr, _
                                          numpoints as long, _
                                          method    as long, _
                                          matrix    as single ptr )


declare function cvFindChessBoardCornerGuesses( arr          as const any ptr, _
                                                thresharr    as any ptr, _
                                                storage      as CvMemStorage ptr, _
                                                pattern_size as CvSize, _
                                                corners      as CvPoint2D32f ptr, _
                                                corner_count as long ptr ) as long

' Calibrates camera using multiple views of calibration pattern
declare sub      cvCalibrateCamera( image_count         as long, _
                                    point_counts        as long ptr, _
                                    image_size          as CvSize, _
                                    image_points        as CvPoint2D32f ptr, _
                                    object_points       as CvPoint3D32f ptr, _
                                    distortion_coeffs   as single ptr, _
                                    camera_matrix       as single ptr, _
                                    translation_vectors as single ptr, _
                                    rotation_matrices   as single ptr, _
                                    flags               as long )


declare sub      cvCalibrateCamera_64d( image_count         as long, _
                                        point_counts        as long ptr, _
                                        image_size          as CvSize, _
                                        image_points        as CvPoint2D64f ptr, _
                                        object_points       as CvPoint3D64f ptr, _
                                        distortion_coeffs   as double ptr, _
                                        camera_matrix       as double ptr, _
                                        translation_vectors as double ptr, _
                                        rotation_matrices   as double ptr, _
                                        flags               as long )

' Find 3d position of object given intrinsic camera parameters,
' 3d model of the object and projection of the object into view plane
declare sub      cvFindExtrinsicCameraParams( point_count        as long, _
                                              image_size         as CvSize, _
                                              image_points       as CvPoint2D32f ptr, _
                                              object_points      as CvPoint3D32f ptr, _
                                              focal_length       as single ptr, _
                                              principal_point    as CvPoint2D32f, _
                                              distortion_coeffs  as single ptr, _
                                              rotation_vector    as single ptr, _
                                              translation_vector as single ptr )

' Variant of the previous function that takes double-precision parameters
declare sub      cvFindExtrinsicCameraParams_64d( point_count        as long, _
                                                  image_size         as CvSize, _
                                                  image_points       as CvPoint2D64f ptr, _
                                                  object_points      as CvPoint3D64f ptr,  _
                                                  focal_length       as double ptr, _
                                                  principal_point    as CvPoint2D64f, _
                                                  distortion_coeffs  as double ptr, _
                                                  rotation_vector    as double ptr, _
                                                  translation_vector as double ptr )

' Rodrigues transform
enum
  CV_RODRIGUES_M2V = 0,
  CV_RODRIGUES_V2M = 1
end enum

' Converts rotation_matrix matrix to rotation_matrix vector or vice versa
declare sub       cvRodrigues( rotation_matrix as CvMat ptr, _
                               rotation_vector as CvMat ptr, _
                               jacobian        as CvMat ptr, _
                               conv_type       as long )

' Does reprojection of 3d object points to the view plane
declare sub       cvProjectPoints( point_count                    as long, _
                                   object_points                  as CvPoint3D64f ptr, _
                                   rotation_vector                as double ptr, _
                                   translation_vector             as double ptr, _
                                   focal_length                   as double ptr, _
                                   principal_point                as CvPoint2D64f, _
                                   distortion                     as double ptr, _
                                   image_points                   as CvPoint2D64f ptr, _
                                   deriv_points_rotation_matrix   as double ptr, _
                                   deriv_points_translation_vect  as double ptr, _
                                   deriv_points_focal             as double ptr, _
                                   deriv_points_principal_point   as double ptr, _
                                   deriv_points_distortion_coeffs as double ptr )


' Simpler version of the previous function/
declare sub       cvProjectPointsSimple( point_count        as long, _
                                         object_points      as CvPoint3D64f ptr, _
                                         rotation_matrix    as double ptr, _
                                         translation_vector as double ptr, _
                                         camera_matrix      as double ptr, _
                                         distortion         as double ptr, _
                                         image_points       as CvPoint2D64f ptr )


#define cvMake2DPoints cvConvertPointsHomogeneous
#define cvMake3DPoints cvConvertPointsHomogeneous

#define cvWarpPerspectiveQMatrix cvGetPerspectiveTransform

#define cvConvertPointsHomogenious cvConvertPointsHomogeneous

type CvSURFParams
  as long   extended
  as long   upright
  as double hessianThreshold
  as long   nOctaves
  as long   nOctaveLayers
end type

declare function cvSURFParams( hessianThreshold as double, extended as long CV_DEFAULT(0) ) as CvSURFParams

' If useProvidedKeyPts!=0, keypoints are not detected, but descriptors are computed
' at the locations provided in keypoints (a CvSeq of CvSURFPoint).
declare sub      cvExtractSURF( img               as const CvArr ptr, _
                                mask              as const CvArr ptr, _
                                keypoints         as CvSeq ptr ptr, _
                                descriptors       as CvSeq ptr ptr, _
                                storage           as CvMemStorage ptr, _
                                params            as CvSURFParams, _
                                useProvidedKeyPts as long CV_DEFAULT(0) )

' Maximal Stable Regions Parameters
type CvMSERParams
  ' delta, in the code, it compares (size_{i}-size_{i-delta})/size_{i-delta}
  as long delta
  ' prune the area which bigger than maxArea
  as long maxArea
  ' prune the area which smaller than minArea
  as long minArea
  ' prune the area have simliar size to its children
  as single maxVariation
  ' trace back to cut off mser with diversity < min_diversity
  as single minDiversity

  ' the next few params for MSER of color image

  ' for color image, the evolution steps
  as long maxEvolution
  ' the area threshold to cause re-initialize
  as double areaThreshold
  ' ignore too small margin
  as double minMargin
  ' the aperture size for edge blur
  as long edgeBlurSize
end type

declare function cvMSERParams( delta          as long   CV_DEFAULT(5), _
                               min_area       as long   CV_DEFAULT(60), _
                               max_area       as long   CV_DEFAULT(14400), _
                               max_variation  as single CV_DEFAULT(.25f), _
                               min_diversity  as single CV_DEFAULT(.2f), _
                               max_evolution  as long   CV_DEFAULT(200), _
                               area_threshold as double CV_DEFAULT(1.01), _
                               min_margin     as double CV_DEFAULT(.003), _
                               edge_blur_size as long   CV_DEFAULT(5) ) as CvMSERParams

' Extracts the contours of Maximally Stable Extremal Regions
declare sub cvExtractMSER( img      as CvArr ptr, _
                           mask     as CvArr ptr, _
                           contours as CvSeq ptr ptr, _
                           storage  as CvMemStorage ptr, _
                           params   as CvMSERParams )


type CvStarDetectorParams
  as long maxSize
  as long responseThreshold
  as long lineThresholdProjected
  as long lineThresholdBinarized
  as long suppressNonmaxSize
end type
' renamed: cvStarDetectorParams
function cv_StarDetectorParams( maxSize                as long CV_DEFAULT(45), _
                                responseThreshold      as long CV_DEFAULT(30), _
                                lineThresholdProjected as long CV_DEFAULT(10), _
                                lineThresholdBinarized as long CV_DEFAULT(8), _
                                suppressNonmaxSize     as long CV_DEFAULT(5) ) as CvStarDetectorParams
  dim as CvStarDetectorParams params
  params.maxSize = maxSize
  params.responseThreshold = responseThreshold
  params.lineThresholdProjected = lineThresholdProjected
  params.lineThresholdBinarized = lineThresholdBinarized
  params.suppressNonmaxSize = suppressNonmaxSize
  return params
end function

declare function cvGetStarKeypoints( img     as const CvArr ptr, _
                                     storage as CvMemStorage ptr, _
                                     params  as CvStarDetectorParams CV_DEFAULT(cv_StarDetectorParams()) ) as CvSeq ptr

end extern ' "C"

