#pragma once

#ifndef __OPENCV__
  #error 666: do not include this file manually include only 'opencv.bi' !
#endif

extern "C"

type Image_FFMPEG
  as ubyte ptr data
  as long      step
  as long      width
  as long      height
  as long      cn
end type


enum
  CV_FFMPEG_CAP_PROP_POS_MSEC      = 0
  CV_FFMPEG_CAP_PROP_POS_FRAMES    = 1
  CV_FFMPEG_CAP_PROP_POS_AVI_RATIO = 2
  CV_FFMPEG_CAP_PROP_FRAME_WIDTH   = 3
  CV_FFMPEG_CAP_PROP_FRAME_HEIGHT  = 4
  CV_FFMPEG_CAP_PROP_FPS           = 5
  CV_FFMPEG_CAP_PROP_FOURCC        = 6
  CV_FFMPEG_CAP_PROP_FRAME_COUNT   = 7
end enum

type CvCapture_FFMPEG extends object
end type
type CvVideoWriter_FFMPEG  extends object
end type

declare function cvCreateFileCapture_FFMPEG(filename as const zstring ptr) as CvCapture_FFMPEG ptr
declare sub      cvReleaseCapture_FFMPEG(cap as CvCapture_FFMPEG ptr ptr)

declare function cvSetCaptureProperty_FFMPEG(cap as CvCapture_FFMPEG ptr, prop as long, value as double) as long
declare function cvGetCaptureProperty_FFMPEG(cap as CvCapture_FFMPEG ptr, prop as long) as double
declare function cvGrabFrame_FFMPEG(cap as CvCapture_FFMPEG ptr) as long
declare function cvRetrieveFrame_FFMPEG(cap    as CvCapture_FFMPEG ptr, _
                                        data_  as ubyte ptr ptr,
                                        step_  as long ptr, _
                                        width_ as long ptr, _
                                        height as long ptr, _
                                        cn     as long ptr) as long

declare function cvCreateVideoWriter_FFMPEG(filename as const zstring ptr, _
                                            fourcc   as long, _
                                            fpas     as double, _
                                            width_   as long, _
                                            height   as long, _
                                            isColor  as long) as CvVideoWriter_FFMPEG ptr
declare function cvWriteFrame_FFMPEG(writer as CvVideoWriter_FFMPEG ptr, _
                                     data_  as const ubyte ptr, _
                                     step_  as long, _
                                     width_ as long, _
                                     height as long, _
                                     cn     as long, _
                                     origin as long) as long 

declare sub      cvReleaseVideoWriter_FFMPEG(writer as CvVideoWriter_FFMPEG ptr ptr)

end extern ' "C"
